=== removed file '.project'
--- .project	2006-12-11 06:44:19 +0000
+++ .project	1970-01-01 00:00:00 +0000
@@ -1,17 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<projectDescription>
-	<name>loggerhead</name>
-	<comment></comment>
-	<projects>
-	</projects>
-	<buildSpec>
-		<buildCommand>
-			<name>org.python.pydev.PyDevBuilder</name>
-			<arguments>
-			</arguments>
-		</buildCommand>
-	</buildSpec>
-	<natures>
-		<nature>org.python.pydev.pythonNature</nature>
-	</natures>
-</projectDescription>

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2008-07-09 08:39:59 +0000
+++ loggerhead/apps/branch.py	2008-08-05 05:17:47 +0000
@@ -23,10 +23,12 @@
 
 class BranchWSGIApp(object):
 
-    def __init__(self, branch, friendly_name=None, config={}, graph_cache=None):
+    def __init__(self, branch, friendly_name=None, config={},
+                 graph_cache=None, branch_link=None):
         self.branch = branch
         self._config = config
         self.friendly_name = friendly_name
+        self.branch_link = branch_link  # Currently only used in Launchpad
         self.log = logging.getLogger('loggerhead.%s' % (friendly_name,))
         if graph_cache is None:
             graph_cache = bzrlib.lru_cache.LRUCache()

=== modified file 'loggerhead/controllers/directory_ui.py'
--- loggerhead/controllers/directory_ui.py	2008-08-04 21:22:16 +0000
+++ loggerhead/controllers/directory_ui.py	2008-08-06 21:25:24 +0000
@@ -30,8 +30,12 @@
         self.parity = parity
         self.branch = branch
         if branch is not None:
-            self.last_change =  datetime.datetime.fromtimestamp(
-                branch.repository.get_revision(branch.last_revision()).timestamp)
+            # If a branch is empty, bzr raises an exception when trying this
+            try:
+                self.last_change =  datetime.datetime.fromtimestamp(
+                    branch.repository.get_revision(branch.last_revision()).timestamp)
+            except:
+                self.last_change = None
 
 class DirectoryUI(TemplatedBranchView):
     """

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-07-26 17:53:10 +0000
+++ loggerhead/history.py	2008-08-06 19:39:07 +0000
@@ -257,13 +257,19 @@
             revid = parents[0]
 
     def get_short_revision_history_by_fileid(self, file_id):
-        # wow.  is this really the only way we can get this list?  by
-        # man-handling the weave store directly? :-0
         # FIXME: would be awesome if we could get, for a folder, the list of
-        # revisions where items within that folder changed.
-        possible_keys = [(file_id, revid) for revid in self._full_history]
-        existing_keys = self._branch.repository.texts.get_parent_map(possible_keys)
-        return [revid for _, revid in existing_keys.iterkeys()]
+        # revisions where items within that folder changed.i
+        try:
+            # FIXME: Workaround for bzr versions prior to 1.6b3. 
+            # Remove me eventually pretty please  :)
+            w = self._branch.repository.weave_store.get_weave(file_id, self._branch.repository.get_transaction())
+            w_revids = w.versions() 
+            revids = [r for r in self._full_history if r in w_revids] 
+        except AttributeError:
+            possible_keys = [(file_id, revid) for revid in self._full_history]
+            existing_keys = self._branch.repository.texts.get_parent_map(possible_keys)
+            revids = [revid for _, revid in existing_keys.iterkeys()]
+        return revids
 
     def get_revision_history_since(self, revid_list, date):
         # if a user asks for revisions starting at 01-sep, they mean inclusive,

=== modified file 'loggerhead/static/css/annotate.css'
--- loggerhead/static/css/annotate.css	2008-07-24 22:00:49 +0000
+++ loggerhead/static/css/annotate.css	2008-08-05 19:44:50 +0000
@@ -1,16 +1,13 @@
 /*table*/
 .annoLineTit, .annoLine, .annoRevTit, .annoRev, .annoComm, .annoCommTit, .annoContTit, .annoCont {
-	padding:4px;
 	width:45px;
 	border:1px solid #d2d2d2;
 }
 .annoLine, .annoRev, .annoComm, .annoCont {
-	padding:5px 0px;
 	border:none;	
 }
 .annoLine {
 	width:37px;
-	padding:5px 4px;
 }
 .annoContTit, .annoCont {
 	width:auto;

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2008-08-05 06:12:07 +0000
+++ loggerhead/static/css/global.css	2008-08-13 17:33:41 +0000
@@ -120,7 +120,7 @@
 #finderBox {
 	width:300px;
 	float:right;
-	padding:0px;
+	padding: 10px 0px 0px 0px;
 }
 #finderBox label {
 	float:left;
@@ -186,7 +186,6 @@
 	padding:0px 11px 0px 0px;
 	margin:0px 2px 0px 0px;
 	font-weight:bold;
-	background:url(../images/ico_link.gif) right top no-repeat;
 }
 .revnolink a, .revnolink a:visited, .revnolink a:link, .revnolink a:hover {
 	color:#CC6600;

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2008-07-26 14:52:44 +0000
+++ loggerhead/templatefunctions.py	2008-08-13 19:51:08 +0000
@@ -74,3 +74,17 @@
     return _pt('modified-file-link-log').expand(
         url=url, entry=entry, item=item,
         **templatefunctions)
+
+@templatefunc
+def search_box(branch, navigation):
+    return _pt('search-box').expand(branch=branch, navigation=navigation,
+        **templatefunctions)
+
+@templatefunc
+def feed_link(branch, url):
+    return _pt('feed-link').expand(branch=branch, url=url, **templatefunctions)
+
+@templatefunc
+def menu(branch, url, fileview_active=False):
+    return _pt('menu').expand(branch=branch, url=url,
+        fileview_active=fileview_active, **templatefunctions)

=== modified file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2008-07-23 23:00:16 +0000
+++ loggerhead/templates/annotate.pt	2008-08-04 03:42:01 +0000
@@ -15,8 +15,16 @@
   <body>
 
     <h1 metal:fill-slot="heading">
-        <tal:block content="branch/friendly_name"></tal:block>
-        <span>: <span tal:content="path"></span> (revision <tal:revno content="change/revno"></tal:revno>)</span>
+      <tal:has-link condition="branch/branch_link">
+        <a tal:attributes="href branch/branch_link"
+           tal:content="branch/friendly_name">
+          nice/branch/name
+        </a>
+      </tal:has-link>
+      <tal:no-link condition="not: branch/branch_link">
+        <tal:branch-name replace="branch/friendly_name" />
+      </tal:no-link>
+      <span>: <span tal:content="path"></span> (revision <tal:revno content="change/revno"></tal:revno>)</span>
     </h1>
 
     <div metal:fill-slot="content">

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2008-07-24 02:40:21 +0000
+++ loggerhead/templates/changelog.pt	2008-08-04 03:42:01 +0000
@@ -14,7 +14,16 @@
     <body>
         <tal:block metal:fill-slot="heading">
          <h1>
-          <tal:block content="branch/friendly_name"></tal:block>: changes
+           <tal:has-link condition="branch/branch_link">
+             <a tal:attributes="href branch/branch_link"
+                tal:content="branch/friendly_name">
+               nice/branch/name
+             </a>
+           </tal:has-link>
+           <tal:no-link condition="not: branch/branch_link">
+             <tal:branch-name replace="branch/friendly_name" />
+           </tal:no-link>
+           : changes
           <tal:block condition="filter_file_id">to <span tal:content="python:history.get_path(revid, filter_file_id)" /></tal:block>
           <tal:block condition="start_revid">from revision <tal:block content="python:history.get_revno(start_revid)" /></tal:block>
           <tal:block condition="query">matching <tal:block content="query" /></tal:block>

=== added file 'loggerhead/templates/feed-link.pt'
--- loggerhead/templates/feed-link.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/feed-link.pt	2008-08-13 15:18:17 +0000
@@ -0,0 +1,6 @@
+<tal:feed-link>
+  <a tal:attributes="href python:url(['/atom']);
+                     title string:RSS feed for ${branch/friendly_name}">
+    <img tal:attributes="src python:branch.static_url('/static/images/ico_rss.gif')" alt="RSS" class="rssfeed"/>
+  </a>
+</tal:feed-link>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2008-07-25 02:05:12 +0000
+++ loggerhead/templates/inventory.pt	2008-08-06 04:20:07 +0000
@@ -11,8 +11,17 @@
   <body>
 
     <h1 metal:fill-slot="heading">
-        <tal:block content="branch/friendly_name" />: viewing 
-        <span><tal:block content="path" /></span> for revision <span><tal:revno content="change/revno"></tal:revno></span>
+      <tal:has-link condition="branch/branch_link">
+        <a tal:attributes="href branch/branch_link"
+           tal:content="branch/friendly_name">
+          nice/branch/name
+        </a>
+      </tal:has-link>
+      <tal:no-link condition="not: branch/branch_link">
+        <tal:branch-name replace="branch/friendly_name" />
+      </tal:no-link>
+      : viewing
+      <span tal:content="path" /> for revision <span tal:content="change/revno"/>
     </h1>
 
     <div metal:fill-slot="content">
@@ -39,7 +48,8 @@
 
           <tr class="blueRow0" tal:condition="python:updir">
               <td class="summcell" colspan="6">
-                  <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)" class="link">..</a>
+                  <a tal:attributes="href python:url(['/files', revid], file_id=updir_file_id)" class="link">
+                      <img tal:attributes="src python:branch.static_url('/static/images/ico_folder_up.gif')" />..</a>
               </td>
           </tr>
           
@@ -54,7 +64,7 @@
                <a tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)" 
                                       tal:content="file/filename" class="link"></a>
                </td>
-               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno], filter_file_id=file.file_id);
+               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
                                                    title string:Show revision ${file/change/revno}"
                                    tal:content="file/change/revno"></a>
                </td>
@@ -77,7 +87,7 @@
                <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)" 
                                       tal:content="file/filename" class="link"></a>
                </td>
-               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno], filter_file_id=file.file_id);
+               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
                                                    title string:Show revision ${file/change/revno}"
                                    tal:content="file/change/revno"></a>
                </td>
@@ -106,7 +116,7 @@
 
             <a tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id)"
                                    tal:content="file/filename" class="link"></a></td>
-            <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno], filter_file_id=file.file_id);
+            <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
                                                 title string:Show revision ${file/change/revno}"
                                 tal:content="file/change/revno"></a>
             </td>

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2008-07-25 19:23:15 +0000
+++ loggerhead/templates/macros.pt	2008-08-13 19:51:08 +0000
@@ -21,41 +21,25 @@
 
 <body>
     <!-- Loggerhead Content Area -->
-    <ul id="menuTabs">
-        <form tal:attributes="action python:branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None), 
-                                                                   file_id=getattr(navigation, 'file_id', None))">
-      	  <div id="finderBox">
-            <label>search:</label> <input type="search" name="q" id="q" autocomplete="off" onblur="hide_search();" /> 
-            <div><a tal:attributes="href python:url(['/atom']);
-                                    title string:RSS feed for ${branch/friendly_name}"> 
-                 <img tal:attributes="src python:branch.static_url('/static/images/ico_rss.gif')" alt="RSS" class="rssfeed"/></a>
-            </div>
-          </div>
-        </form>
-        
-        <tal:block tal:condition="not:fileview_active">
-        <li><a tal:attributes="href python:url('/changes', clear=1);
-                               title string:Changes;
-                               id string:on">Changes</a></li>
-        <li><a tal:attributes="href python:url('/files', clear=1);
-                               title string:Files">Files</a></li>
-        </tal:block>
-        <tal:block tal:condition="fileview_active">
-        <li><a tal:attributes="href python:url('/changes', clear=1);
-                               title string:Changes">Changes</a></li>
-        <li><a tal:attributes="href python:url('/files', clear=1);
-                               title string:Files;
-                               id string:on">Files</a></li>
-        </tal:block>
-      </ul>
+      <div id="finderBox">
+         <tal:search-box define="navigation navigation"
+                        replace="structure python:search_box(branch,
+                                 navigation)" />
+        <div>
+          <tal:feed-link replace="structure python:feed_link(branch, url)" />
+        </div>
+      </div>
+
+      <tal:menu define="fileview_active fileview_active"
+                replace="structure python:menu(branch, url, fileview_active)" />
       <div id="loggerheadCont">
-    
-         <div id="search_terms"></div>
+
+        <div id="search_terms"></div>
 
         <h1 metal:define-slot="heading"></h1>
         <div metal:define-slot="content"></div>
 
         <p class="fl">Loggerhead runs on <a href="http://bazaar-vcs.org/" class="link">Bazaar</a> branches</p>
-    </div>
+      </div>
   </body>
 </html>

=== added file 'loggerhead/templates/menu.pt'
--- loggerhead/templates/menu.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/menu.pt	2008-08-13 17:33:41 +0000
@@ -0,0 +1,19 @@
+<tal:menu>
+    <ul id="menuTabs">
+        <tal:changes-active tal:condition="not:fileview_active">
+        <li><a tal:attributes="href python:url('/changes', clear=1);
+                               title string:Changes;
+                               id string:on">Changes</a></li>
+        <li><a tal:attributes="href python:url('/files', clear=1);
+                               title string:Files">Files</a></li>
+        </tal:changes-active>
+        <tal:fileview-active tal:condition="fileview_active">
+        <li><a tal:attributes="href python:url('/changes', clear=1);
+                               title string:Changes">Changes</a></li>
+        <li><a tal:attributes="href python:url('/files', clear=1);
+                               title string:Files;
+                               id string:on">Files</a></li>
+        </tal:fileview-active>
+      </ul>
+</tal:menu>
+

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2008-07-24 00:17:48 +0000
+++ loggerhead/templates/revision.pt	2008-08-04 03:42:01 +0000
@@ -15,7 +15,17 @@
     <body>
 
       <tal:block metal:fill-slot="heading">
-        <h1><tal:block content="branch/friendly_name" /><span>: <tal:revno content="change/revno"></tal:revno>
+        <h1>
+          <tal:has-link condition="branch/branch_link">
+            <a tal:attributes="href branch/branch_link"
+               tal:content="branch/friendly_name">
+              nice/branch/name
+            </a>
+          </tal:has-link>
+          <tal:no-link condition="not: branch/branch_link">
+            <tal:branch-name replace="branch/friendly_name" />
+          </tal:no-link>
+          <span>: <tal:revno content="change/revno"></tal:revno>
         <tal:compare-to condition="python:compare_revid is not None">
           (compared to revision <tal:block content="python:history.get_revno(compare_revid)" />)
           </tal:compare-to>

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2008-07-25 02:06:37 +0000
+++ loggerhead/templates/revisioninfo.pt	2008-08-05 19:25:28 +0000
@@ -13,7 +13,7 @@
                tal:content="python:revno_with_nick(merge_point)"></a>
         </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
-        <div class="information" tal:content="change/comment"></div>
+        <div class="information" tal:content="python:util.fixed_width(change.comment)"></div>
     </div>
     <ul id="list-files">
         <tal:block condition="nocall:modified_file_link">

=== added file 'loggerhead/templates/search-box.pt'
--- loggerhead/templates/search-box.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/search-box.pt	2008-08-13 17:24:10 +0000
@@ -0,0 +1,10 @@
+<tal:search-box>
+  <form tal:attributes="action python:branch.url('/changes',
+                            start_revid=getattr(navigation,
+                            'start_revid', None),
+                            file_id=getattr(navigation, 'file_id', None))">
+    <label>search:</label>
+    <input type="search" name="q" id="q" autocomplete="off" onblur="hide_search();" />
+  </form>
+</tal:search-box>
+

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2008-07-26 17:53:10 +0000
+++ loggerhead/util.py	2008-08-06 21:25:24 +0000
@@ -59,7 +59,10 @@
 
 
 def date_time(value):
-    return value.strftime('%Y-%m-%d %T')
+    if value is not None:
+        return value.strftime('%Y-%m-%d %T')
+    else:
+        return 'N/A'
 
 
 def _displaydate(date):

=== added file 'serve-branches.1'
--- serve-branches.1	1970-01-01 00:00:00 +0000
+++ serve-branches.1	2008-08-05 16:07:16 +0000
@@ -0,0 +1,29 @@
+.TH LOGGERHEAD "1" "August 2008" "loggerhead 1.6" "User Commands"
+.SH NAME
+loggerhead \- run a loggerhead server
+.SH SYNOPSIS
+.B serve-branches
+[\fIoptions\fR] \fI<path>\fR
+.SH DESCRIPTION
+Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
+a branch history, annotate files, view patches, perform searches, etc. It's 
+heavily based on bazaar-webserve, which is itself based on hgweb for Mercurial.
+.PP
+The serve-branches command runs a standalone loggerhead server in the foreground.
+.SH OPTIONS
+.TP
+\fB\-h\fR, \fB\-\-help\fR
+show this help message and exit
+.TP
+\fB\-\-user\-dirs\fR
+Serve user directories as ~user.
+.TP
+\fB\-\-trunk\-dir\fR=\fIDIR\fR
+The directory that contains the trunk branches.
+.TP
+\fB\-\-version\fR
+Print the software version and exit
+.SH "LICENSE"
+GNU GPLv2 or later.
+.SH "SEE ALSO"
+https://launchpad.net/loggerhead

=== modified file 'setup.py'
--- setup.py	2008-07-31 04:49:15 +0000
+++ setup.py	2008-08-05 16:02:23 +0000
@@ -31,10 +31,17 @@
     maintainer = "Michael Hudson",
     maintainer_email = "michael.hudson@canonical.com",
     scripts = ["start-loggerhead", "stop-loggerhead", "serve-branches"],
-    packages = ["loggerhead"],
-    package_data = {"loggerhead":["templates/*.pt"]},
+    packages = ["loggerhead", 
+                "loggerhead/apps", 
+                "loggerhead/controllers", 
+                "loggerhead/templates"],
+    package_data = {"loggerhead":["templates/*.pt", 
+                                  "static/css/*.css", 
+                                  "static/javascript/*", 
+                                  "static/images/*"]},
     data_files = [
-        ('share/man/man1',['start-loggerhead.1', 'stop-loggerhead.1']),
+        ('share/man/man1',['start-loggerhead.1', 'stop-loggerhead.1', 
+                           'serve-branches.1']),
         ('share/doc/loggerhead', ['loggerhead.conf.example']),
         ],
     )

=== modified file 'start-loggerhead'
--- start-loggerhead	2008-07-26 17:53:10 +0000
+++ start-loggerhead	2008-08-06 19:38:14 +0000
@@ -29,7 +29,7 @@
 from paste.httpexceptions import make_middleware
 from paste.translogger import make_filter
 
-from loggerhead import daemon, release
+from loggerhead import daemon
 from loggerhead.apps.config import Root
 
 
@@ -44,10 +44,9 @@
     return h
 
 
-def setup_logging(home, config, foreground):
+def setup_logging(log_folder, config, foreground):
     # i hate that stupid logging config format, so just set up logging here.
 
-    log_folder = os.path.join(home, 'logs')
     if not os.path.exists(log_folder):
         os.mkdir(log_folder)
 
@@ -76,33 +75,37 @@
 
 
 def main():
-    parser = OptionParser(usage='usage: %prog [options]', version='%prog ' + release.version)
+    home = os.path.realpath(os.path.dirname(__file__))
+    default_pidfile = os.path.join(home, 'loggerhead.pid')
+    default_configfile = os.path.join(home, 'loggerhead.conf')
+    default_log_folder = os.path.join(home, 'logs')
+    parser = OptionParser(usage='usage: %prog [options]', version='%prog')
     parser.add_option('-f', '--foreground', action='store_true', dest='foreground', default=False,
                       help="run in the foreground; don't daemonize")
     parser.add_option('-C', '--check', action='store_true', dest='check', default=False,
                       help="only start if not already running (useful for cron jobs)")
+    parser.add_option('-p', '--pidfile', dest="pidfile", default=default_pidfile,
+                      type=str, help="override pidfile location")
+    parser.add_option('-c', '--config-file', dest="configfile", default=default_configfile,
+					  type=str, help="override configuration file location")
+    parser.add_option('-L', '--log-folder', dest="log_folder", default=default_log_folder,
+                      type=str, help="override log file directory")
     options, args = parser.parse_args()
     if len(args) > 0:
         parser.error('No filename arguments are used, only options.')
 
-
-    home = os.path.realpath(os.path.dirname(__file__))
-    pidfile = os.path.join(home, 'loggerhead.pid')
-
     if options.check:
-        if daemon.is_running(pidfile):
+        if daemon.is_running(options.pidfile):
             sys.exit(0)
-        sys.stderr.write('Did not find loggerhead running in %r; restarting...\n' % (pidfile,))
+        sys.stderr.write('Did not find loggerhead running in %r; restarting...\n' % (options.pidfile,))
 
     # read loggerhead config
 
-    config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
+    config = ConfigObj(options.configfile, encoding='utf-8')
     extra_path = config.get('bzrpath', None)
     if extra_path:
         sys.path.insert(0, extra_path)
 
-    #turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
-
     potential_overrides = [ ('server.socket_port', int),
                             ('server.webpath', str),
                             ('server.thread_pool', int),
@@ -116,17 +119,16 @@
         value = config.get(key, None)
         if value is not None:
             value = keytype(value)
-            #turbogears.config.update({ key: value })
 
     if not options.foreground:
         sys.stderr.write('\n')
         sys.stderr.write('Launching loggerhead into the background.\n')
-        sys.stderr.write('PID file: %s\n' % (pidfile,))
+        sys.stderr.write('PID file: %s\n' % (options.pidfile,))
         sys.stderr.write('\n')
 
-        daemon.daemonize(pidfile, home)
+        daemon.daemonize(options.pidfile, home)
 
-    setup_logging(home, config, foreground=options.foreground)
+    setup_logging(options.log_folder, config, foreground=options.foreground)
 
     log = logging.getLogger('loggerhead')
     log.info('Starting up...')
@@ -151,7 +153,7 @@
     finally:
         log.info('Shutdown.')
         try:
-            os.remove(pidfile)
+            os.remove(options.pidfile)
         except OSError:
             pass
 

=== modified file 'start-loggerhead.1'
--- start-loggerhead.1	2008-07-26 14:09:59 +0000
+++ start-loggerhead.1	2008-08-06 18:33:20 +0000
@@ -23,6 +23,15 @@
 .TP
 \fB\-C\fR, \fB\-\-check\fR
 only start if not already running (useful for cron jobs)
+.TP
+\fB\-p\fR, \fB\-\-pidfile=PIDFILE\fR
+override pid file location
+.TP
+\fB\-c\fR, \fB\-\-config-file=CONFIGFILE\fR
+override configuration file location
+.TP
+\fB\-L\fR, \fB\-\-log-folder=LOG-FOLDER\fR
+override log directory
 .SH "LICENSE"
 GNU GPLv2 or later.
 .SH "SEE ALSO"

=== modified file 'stop-loggerhead'
--- stop-loggerhead	2008-08-04 23:46:37 +0000
+++ stop-loggerhead	2008-08-06 19:38:14 +0000
@@ -17,14 +17,22 @@
 
 import os
 import sys
+from optparse import OptionParser
 
 home = os.path.realpath(os.path.dirname(__file__))
-pidfile = os.path.join(home, 'loggerhead.pid')
+default_pidfile = os.path.join(home, 'loggerhead.pid')
+parser = OptionParser(usage='usage: %prog [options]', version='%prog')
+parser.add_option('-p', '--pidfile', dest="pidfile", default=default_pidfile,
+				  help="override pidfile location")
+
+options, args = parser.parse_args()
+if len(args) > 0:
+	parser.error('No filename arguments are used, only options.')
 
 try:
-    f = open(pidfile, 'r')
+    f = open(options.pidfile, 'r')
 except IOError, e:
-    print 'No pid file found.'
+    print 'Pid file %s not found.' % options.pidfile
     sys.exit(1)
 
 pid = int(f.readline())

=== modified file 'stop-loggerhead.1'
--- stop-loggerhead.1	2008-07-26 14:09:59 +0000
+++ stop-loggerhead.1	2008-08-06 18:39:15 +0000
@@ -7,6 +7,10 @@
 Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
 a branch history, annotate files, view patches, perform searches, etc. It's 
 heavily based on bazaar-webserve, which is itself based on hgweb for Mercurial.
+.SH OPTIONS
+.TP
+\fB\-p\fR, \fB\-\-pidfile=PIDFILE\fR
+override pid file location
 .PP
 The stop-loggerhead command stops the currently running loggerhead server.
 .SH "LICENSE"

